      PROGRAM FAST
                  
      IMPLICIT REAL*8 (A-H,O-Z)
      INTEGER J,L,OM,OMAX,P,PE,Q
      REAL*8 K,PI,M1,M2

C     NPAR  = number of parameters in the model
C     N     = integer at our choice related to interferences       
C     NSMAX = maximum number admissible of model evaluations        

      PARAMETER(NPAR=5,
     +          N=4,
     +          NSMAX=2000)  
      
      DIMENSION OM(NPAR),S(NSMAX),K(NPAR),U(NSMAX),A(NPAR,N),B(NPAR,N),
     +          VAR(NPAR),AC(NSMAX),BC(NSMAX),SI(NPAR)
      
      PI=4*DATAN(1.D0)
      VARTOT=0.D0
      
            
C---------------------         
C     SETTING THE FREQUENCIES 
C---------------------
C       DATA (OM(L),L=1,NPAR) //
       DATA (OM(L),L=1,NPAR) /11,21,27,35,39/
C       DATA (OM(L),L=1,NPAR) /11,17,23,31,79/
C      DATA (OM(L),L=1,NPAR) /1,21,31,37,45,49/
C      DATA (OM(L),L=1,NPAR) /17,39,59,69,75,83,87/
C      DATA (OM(L),L=1,NPAR) /23,55,77,97,107,113,121,125/
C      DATA (OM(L),L=1,NPAR) /19,59,91,113,133,143,149,157,161/
C      DATA (OM(L),L=1,NPAR) /25,63,103,135,157,177,187,193,201,205/
c      DATA (OM(L),L=1,NPAR) /41,67,105,145,177,199,219,229,235,243,247/
       
        open(unit=20,file='ppp',status='unknown')
C-------------------
C     COMPUTATION OF THE MAX FREQUENCY "OMAX" AND OF SAMPLE POINTS
C-------------------

      OMAX=OM(NPAR)
              
      NS=2*N*OMAX+1      
C      NS=89
      write(*,11) NS
11    format(1x,'Numero samples ---> ',i3)
      
      IF (NS.GT.NSMAX) THEN
        WRITE(*,*)'Warning: NS>NSMAX! Choose NSMAX greater'  
      END IF
      
    
C----------------------------
C     DEFINITION OF:
C                      1) SEARCH CURVE ABSCISSA
C                      2) TRANSFORMATIONS K_l=G_l(SIN OM_l S) [SUBR. PARCOMB]
C                      3) TRANSFER FUNCTION [SUBR 'MODEVAL']
C----------------------------

      DO J=1,NS
        S(J)=PI/2*(2*J-NS-1)/NS
        CALL PARCOMB(OM,NPAR,S(J),K)        
	write(20,*) S(j),K(1)
        CALL MODEVAL(K,NPAR,U(J))
      END DO
	close(20)
	stop
C-----------------------------------------
C     COMPUTATION OF FOURIER COEFFICIENTS
C-----------------------------------------

      NQ=(NS-1)/2
      N0=NQ+1      
      DO J=1,NS
        IF (MOD(J,2).EQ.0) THEN       ! J IS EVEN
          SP1=U(N0)
          DO Q=1,NQ
            SP1=SP1+(U(N0+Q)+U(N0-Q))*DCOS(J*Q*PI/NS)
          END DO
          AC(J)=SP1/NS          
        ELSE                          ! J IS ODD
          SP2=0.D0
          DO Q=1,NQ
            SP2=SP2+(U(N0+Q)-U(N0-Q))*DSIN(J*Q*PI/NS)
          END DO
          BC(J)=SP2/NS
        END IF
      END DO

C----------------------------------
C     COMPUTE GENERAL VARIANCE IN THE FREQUENCY DOMAIN
C----------------------------------
      
      VARTOT=0.D0
      DO J=1,NS
        VARTOT=VARTOT+AC(J)**2+BC(J)**2
      END DO
      VARTOT=2*VARTOT          
C      WRITE(*,*) VARTOT

C-------------------------------------
C     COMPUTE PARTIAL VARIANCES
C-------------------------------------
    
      ASI=0.D0
      DO L=1,NPAR
        VAR(L)=0.D0
        DO P=1,N
         VAR(L)=VAR(L)+AC(P*OM(L))**2+BC(P*OM(L))**2
        END DO
        VAR(L)=2*VAR(L)
        SI(L)=VAR(L)/VARTOT
        ASI=ASI+SI(L)
      END DO      
      ASI=ASI/NPAR
      WRITE(*,30) ASI
30    FORMAT(1X,'AVERAGED SENSITIVITY INDEX ---> ', 1PE12.5)  
      
	STOP
      END
C2345678901234567890123456789012345678901234567890123456789012345678901   
